/******************************************************************************
*
* official project name:  CPoker 92Plus
* project language:       TI-GCC / English
* author:                 Greg S. <IAmHuman@softhome.net>
* file title:             CMisc.c
* initial file date:      ** unknown **
* file purpose:           miscellaneous functions
*
*******************************************************************************/

int determineSuite(int p1[], int p2[]) { //should be flawless
  int q=0; //default=nothing
  if (p1[0]==p1[1] || p1[1]==p1[2] || p1[2]==p1[3] || p1[3]==p1[4]) { //at least one pair
       if ((p1[0]==p1[1] && p1[1]==p1[2]) || (p1[1]==p1[2] && p1[2]==p1[3]) || (p1[2]==p1[3] && p1[3]==p1[4])) {
               q=3; //three of a kind
       }
       else if ((p1[0]==p1[1] && p1[2]==p1[3]) || (p1[1]==p1[2] && p1[3]==p1[4]) || (p1[0]==p1[1] && p1[3]==p1[4])) {
               q=2; //two pairs
       }
       else {
               q=1; //one pair
       }
  }
  if (p1[0]==p1[1]+1 && p1[1]==p1[2]+1 && p1[2]==p1[3]+1 && p1[3]==p1[4]+1)
               q=4; //straight
  if (p2[0]==p2[1] && p2[1]==p2[2] && p2[2]==p2[3] && p2[3]==p2[4])
               q=5; //flush
  if (q==3) { //still three of a kind
       if ((p1[0]==p1[1] && p1[1]==p1[2] && p1[2]==p1[3]) || (p1[1]==p1[2] && p1[2]==p1[3] && p1[3]==p1[4])) {
               q=7; //four of a kind
       }
       else if ((p1[0]==p1[1] && p1[1]==p1[2] && p1[3]==p1[4] && p1[2]==p1[3]) || (p1[0]==p1[1] && p1[1]!=p1[2] && p1[2]==p1[3] && p1[3]==p1[4])) {
               q=6; //full house
       }
  }
  if (q==5) { //same suite
       if (p1[0]==13 && p1[1]==12 && p1[2]==11 && p1[3]==10 && p1[4]==01 && p2[0]==3) {
               q=9; //royal flush!
       }
       else if (p1[0]==p1[1]+1 && p1[1]==p1[2]+1 && p1[2]==p1[3]+1 && p1[3]==p1[4]+1) {
               q=8; //straight flush
       }
  }
  return q;
}

char *checkForDblCard(int nums[], int pics[]) {
  if ((nums[0]==nums[1] && pics[0]==pics[1]) ||
      (nums[0]==nums[2] && pics[0]==pics[2]) ||
      (nums[0]==nums[3] && pics[0]==pics[3]) ||
      (nums[0]==nums[4] && pics[0]==pics[4]) ||
      (nums[1]==nums[2] && pics[1]==pics[2]) ||
      (nums[1]==nums[3] && pics[1]==pics[3]) ||
      (nums[1]==nums[4] && pics[1]==pics[4]) ||
      (nums[2]==nums[3] && pics[2]==pics[3]) ||
      (nums[2]==nums[4] && pics[2]==pics[4]) ||
      (nums[3]==nums[4] && pics[3]==pics[4]))
   return "true";
  else
   return "false";
}

long cmpfunc(void *a, void *b) { //comparison function for qsort [descending]
  return *(int*)b - *(int*)a; //note: typecasts are necessary
}

void Text(char *msg) {
  int strWid=strlen(msg)*6;
  int x=(239-strWid)/2;
  int y=59;

  ClearScreen();
  FontSetSys(F_6x8);
  DrawStr(x, y, msg, A_NORMAL);
  DrawBox(x-2, y-2, x+strWid+2, y+8, A_NORMAL);
  pause();
}